/*	
 *	clipsn7.h
 *
 *	P/ECE SN76489/SN76496 Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Mon Jan 12 18:00:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 *	* Mon Mar 30 19:00:00 JST 2004 Naoyuki Sawa
 *	- ̂߁A炩volumeXP[OĂ悤ɂ܂B
 *	- sn76489_tone_process(),sn76489_noise_process()ɂāA
 *	  {[0̏ꍇ͒ɏԂ悤ɂ܂B
 *	  ĂȂ`l΍҂ł܂B
 */
#ifndef __CLIP_SN7_H__
#define __CLIP_SN7_H__

/****************************************************************************
 *	
 ****************************************************************************/

/* o͂t16bitƂȂ悤Ae`lvolume炩߃XP[OĂ܂B
 * * e`l̃{[0`15Ao͂-15`15łB(t5bit)
 *   S4`lȂ̂ŁAt5bit~4t7bitB
 *   ]āAo͂16bitƂȂɂvolume(16-7)bitVtgĂ܂B
 *   ۂɂ͑S`lĂ邱Ƃ͏Ȃ̂ŁAʂ傫߂ɂ܂B
 *   ̂ߗ]1bitVtg邱ƂɂAVtg(16-7+1)Ƃ܂܂B
 */
#define SN76489_VOLUME_SHIFT	(16 - 7 + 1)
				//        +-

/* Tone Channel (#0-2) */
typedef struct _SN76489TONE {
	int volume;		/*  (0`15)<<SN76489_VOLUME_SHIFT */
	int period;		/* o͋ɐ] */
	//
	int progress;		/* NbNisJE^ */
	int output;		/* o͋ɐ (0:/1:) */
} SN76489TONE;

/* Noise Channel (#3) */
typedef struct _SN76489NOISE {
	int volume;		/*  (0`15)<<SN76489_VOLUME_SHIFT */
	int period;		/* LFSRVtg */
	int feedback;		/* ^bvrbg */
	//
	int progress;		/* NbNisJE^ */
	int lfsr;		/* LFSR(Linear Feedback Shift Register) */
				/* LFSRbit0o͋ɐł (0:/1:) */
} SN76489NOISE;

/* SN76489 Chip */
typedef struct _SN76489 {
	int latch_channel;	/* b``lԍ */
	SN76489TONE tone[3];	/* g[`l0`2 */
	SN76489NOISE noise;	/* mCY`l */
	//
	DDA progress;		/* NbNisDDA */
} SN76489;

#define SN76489NOISE_PERIODIC	0x0001	/* mCỸ^bvrbg */
#define SN76489NOISE_WHITE	0x0009	/* zCgmCỸ^bvrbg() */

/****************************************************************************
 *	֐
 ****************************************************************************/

/* SN76489̓NbNcycle[TCN]i߂āASN76489Ŝ̏o͒l擾܂B
 * [in]
 *	sn		SN76489\́B
 *	cycle		o߃TCNB
 */
int sn76489_process(SN76489* sn, int cycle);

/* SN76489̓NbNcycle[TCN]i߂āAg[1`l̏o͒l擾܂B
 * [in]
 *	sn		SN76489\́B
 *	tone		SN76489TONE\́B
 *	cycle		o߃TCNB
 */
int sn76489_tone_process(SN76489* sn, SN76489TONE* tone, int cycle);

/* SN76489̓NbNcycle[TCN]i߂āAmCY1`l̏o͒l擾܂B
 * [in]
 *	sn		SN76489\́B
 *	noise		SN76489NOISE\́B
 *	cycle		o߃TCNB
 */
int sn76489_noise_process(SN76489* sn, SN76489NOISE* noise, int cycle);

/****************************************************************************
 *	AvP[Vp֐
 ****************************************************************************/

/* SN76489RAZbg܂B
 * [in]
 *	sn		SN76489\́B
 *	clock		̓NbNB
 * [note]
 *	* AvP[VvÓAȂƂŏɈxÅ֐ĂяoĂB
 *	  ̌́ASN76489ZbgsꍇɁAKvɉČĂяoĂB
 */
void sn76489_reset(SN76489* sn, int clock);

/* SN764891oCg݂܂B
 * [in]
 *	sn		SN76489\́B
 *	data		ރf[^B
 */
void sn76489_write(SN76489* sn, unsigned char data);

/* o̓TvO[g=SPEAKER_OUTPUT[Hz]ŁAw肳ꂽTṽ~LVOs܂B
 * [in]
 *	sn		SN76489\́B
 *	wbuff		o̓Tvobt@B
 *	count		o̓TvB
 */
void sn76489_mix(SN76489* sn, short wbuff[/*count*/], int count);

#endif /*__CLIP_SN7_H__*/
