/*
 *	main.c
 *
 *	YM Player
 *
 *	* Wed Apr 21 00:00:00 JST 2004 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

typedef struct _YMFILE {
	char fname[MAXFILENAME + 1];		/* t@C */
	int size;				/* t@CTCY */
} YMFILE;

#define MAX_DISP	13			/* Sɕ\łt@C */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int draw;				/* ĕ`tO */
int now;				/* O[o^C} */
int joy;				/* pbh */

YMFILE ym_file[MAXDIR];			/* YMt@CXg */
int ym_count;				/* YMt@C̐   */
int cursel;				/* ݂̑It@CCfNX */
int curtop;				/* ŏi\t@CCfNX */
int curplay = -1;			/* Đt@CCfNX */

unsigned char ym_data[176 * 1024];	/* WJobt@(TCY) */
int ym_size;				/* YMt@Cf[^WJTCY */
YMINFO ym_info;				/* YMt@C(curplay!=-1̎̂ݗL) */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void err_disp(const char* fmt, ...);
void app_init();
void app_exit();
void schedule();
void run();
int do_play(const char* fname);

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	run();

	return 0;
}

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int len, x, y;
	char str[100]; /* ꂮ炢Ώ[H */
	va_list ap;

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 3);
	draw = 1;
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

static int
ym_file_compare(const void* _a, const void* _b)
{
	YMFILE* a = (YMFILE*)_a;
	YMFILE* b = (YMFILE*)_b;
	return strcmp(a->fname, b->fname);
}

void
app_init()
{
	int retval, len;
	FILEINFO fi;
	YMFILE* yf;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* YMt@CT܂B */
	memset(ym_file, 0, sizeof ym_file);
	ym_count = 0;
	yf = &ym_file[0];
	retval = pceFileFindOpen(&fi);
	if(retval != 0) DIE();
	while(ym_count < MAXDIR) {
		retval = pceFileFindNext(&fi);
		if(!retval) break; /* t@CȂ */
		/* gq".ym"̃t@Ĉ݊i[܂B */
		len = strlen(fi.filename);
		if(len < 3) continue;
		if(strcasecmp(&fi.filename[len - 3], ".ym") == 0) {
			/* t@CƃTCYi[܂B */
			if(len > MAXFILENAME) DIE();
			memcpy(yf->fname, fi.filename, len);
			yf->size = fi.length;
			ym_count++;
			yf++;
		}
	}
	pceFileFindClose(&fi);
	if(ym_count == 0) {
		err_disp("YMt@C܂");
		exit(0);
	}

	/* t@CɃ\[gB */
	qsort(ym_file, ym_count, sizeof(YMFILE), ym_file_compare);

	/* 48MHz/1WAIT[hB */
	turbo(7);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x, y;

	/* ɃX^oCɗȂ悤ɁB */
	pceAppActiveResponse(AAR_ACTIVE);

	/* drcʕ\XV̂߁AʍXVvȂĂAb1͋ʍXVB */
	if(now % SEC(1) == 0) {
		draw = 1;
	}

	/* ʍXVB */
	if(draw) {
		pceLCDTrans();
		draw = 0;
	}

	/* VXeB */
	yield();

	/* pbhԍXVB */
	joy = pcePadGet();

	/* O[o^C}XVB */
	now++;

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT
}

/****************************************************************************
 *	run
 ****************************************************************************/

void
run()
{
	int retval, i, x, y, c, i_ym;
	YMFILE* yf;

	goto L10; /* ͋` */
	for(;;) {
		schedule();

		/* pbh͂Ȃ΁A܂B */
		if(!joy) continue;

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* t@CIύXH */
		if(curplay == -1) { /* ~̂ */
			if(joy & TRG_UP && cursel > 0             ) cursel--;
			if(joy & TRG_DN && cursel < ym_count - 1) cursel++;
			if(joy & TRG_LF) {
				cursel -= MAX_DISP;
				if(cursel < 0) cursel = 0;
			}
			if(joy & TRG_RI) {
				cursel += MAX_DISP;
				if(cursel > ym_count - 1) cursel = ym_count - 1;
			}
			if(cursel < curtop                 ) curtop = cursel                 ;
			if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);
		}

		/* ĐJnH */
		if(joy & TRG_A) {
			ym_stop(); /* t@C񒆂̃mCY}邽߁AIɒ~ */
			yf = &ym_file[cursel];
			if(curplay == -1) { /* ~WJAĐ */
				retval = do_play(yf->fname);
			} else { /* ĐX^[g */
				retval = ym_play(ym_data, ym_size);
			}
			if(retval == 0) {
				curplay = cursel;
			} else {
				err_disp("Đł܂ł");
				curplay = -1;
				/* p */
			}
		}

		/* Đ~H */
		if(joy & TRG_B) {
			ym_stop();
			curplay = -1;
		}

L10:
		/* t@CXg\B */
		memset(vbuff, 0, sizeof vbuff);
		yf = &ym_file[curtop];
		y = 8;
		for(i = 0; i < MAX_DISP + 1/*ɏ镪`*/; i++) {
			i_ym = curtop + i;
			if(i_ym > ym_count - 1) break;
			if(i_ym == cursel) {
				if(i_ym == curplay) {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 1);
					c = 3;
				} else {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 2);
					c = 0;
				}
			} else {
				if(i_ym == curplay) {
					c = 3;
				} else {
					c = 2;
				}
			}
			render_string(&render, 4 + 4 *  1, y, yf->fname, 0x82, c);
			render_printf(&render, 4 + 4 * 15, y, 0x82, c, "%8d bytes", yf->size);
			yf++;
			y += 6;
		}

		/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
		render_rectangle_fill(&render, 0, 0, DISP_X, 6 + 1, 3);
		render_string(&render, 0, 1,
		//       0123456789012345678901234567890123
			"=========== YM Player ============",
			0x82, 0);
		if(curplay != -1) { /* tȂYMt@C\ */
			x = 0;
			y = 8 + 6 * 2;
			render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 * 9 - 2, 3);
			render_printf(&render, x +  4, y, 0x82, 0, "Name:"								); y += 6;
			render_printf(&render, x +  8, y, 0x82, 1, ym_info.name_of_the_song						); y += 6;
			render_printf(&render, x +  4, y, 0x82, 0, "Author:"								); y += 6;
			render_printf(&render, x +  8, y, 0x82, 1, ym_info.name_of_the_author						); y += 6;
			render_printf(&render, x +  4, y, 0x82, 0, "Comment:"								); y += 6;
			render_printf(&render, x +  8, y, 0x82, 1, ym_info.comments							); y += 6;
			render_line(&render, 0, y + 1, DISP_X, y + 1, 2);
																	   y += 3;
			render_printf(&render, x +  4, y, 0x82, 0, "Player frq: %d Hz", ym_info.player_frequency_in_hz			);
			render_printf(&render, x + 86, y, 0x82, 0, "File: %s", ym_info.id_of_format					); y += 6;
			render_printf(&render, x +  4, y, 0x82, 0, "YM-frq: %5.2f MHz", ym_info.ym2149_external_frequency_in_hz / 1e6f	); y += 6;
		}

		/* ʓ]B */
		draw = 1;
	}
}

/****************************************************************************
 *	do_play
 ****************************************************************************/

int
do_play(const char* fname)
{
	const void* romp;
	int size;
	LZH lzh;
	LZHDIR dir;

	/* WJobt@OɁAmɒ~܂B */
	ym_stop();

	/* WJɎԂ̂ŁAbZ[W\B */
	render_string_framed(&render, (DISP_X - (5 * 17 + 1)) / 2, (DISP_Y - (10 + 1)) / 2, "tł...", 0x80, 0x320);
	draw = 1; /* ʓ] */
	schedule();

	/* YMt@CLZHWJ܂B */
	romp = mmap(fname, &size, 1/*DEFRAG*/);
	if(!romp) return -1;
	if(lzh_init(&lzh, romp, size) != 0) return -1;
	if(lzh_dir(&lzh, &dir) != 0) return -1;
	ym_size = lzh_uncompress(&lzh, dir.pathname, ym_data, sizeof ym_data);
	if(ym_size < 0) return -1;

	/* YMt@C擾܂B */
	if(ym_get_info(&ym_info, ym_data, ym_size) != 0) return -1;

	/* ĐJnB */
	if(ym_play(ym_data, ym_size) != 0) return -1;

	return 0;
}

